let sessionNumber = 47;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(!jsonData.gradedTest.s47){

	try {

        if (!fs.existsSync('./sessions/fullstack/s47/activity/index.html')) {
            throw new Error('File not found');
        }
		// Variable to store passing unit test scores for the session
		let passingTests = 0;
		// Variable to store total number of session unit tests
		let totalTests = 0;
			

		describe(`s${sessionNumber}`, function () {

			this.timeout(30000);

			let driver;
			let vars;
		
			let internalCssTestPassed = false;
		
			function parsePixels(value) {
				return parseFloat(value.replace('px', ''));
			}

			let startTime;

			before(async function() {
			  startTime = performance.now();
			  // Any setup code you need to run before the tests start
			  driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
			});

			const options = new firefox.Options();
			options.headless();

			options.setPreference('browser.download.manager.showWhenStarting', false);
			options.setPreference('browser.download.manager.useWindow', false);

			beforeEach(async function() {

			  totalTests += 1;
			  vars = {}
			})

			afterEach(function(){

				if(this.currentTest.state === "passed"){
					passingTests += 1;
				}

				process.removeAllListeners(); 

			})

			it("check if input and output elements exist", async () => {

                const filePath = path.join(__dirname, '..','fullstack','s47','activity','index.html');
                const url = `file://${filePath}`;
                await driver.get(url);

                const firstNameInput = await driver.findElements(By.id('txt-first-name'));
                expect(firstNameInput.length).to.equal(1, 'Could not locate input element');

                const lastNameInput = await driver.findElements(By.id('txt-last-name'));
                expect(lastNameInput.length).to.equal(1, 'Could not locate input element');
            
                const outputElement = await driver.findElements(By.id('output'));
                expect(outputElement.length).to.equal(1, 'Could not locate output element');
            
			})

            it("check if first name and last name input is shown in output element", async () => {

                const filePath = path.join(__dirname, '..','fullstack','s47','activity','index.html');
                const url = `file://${filePath}`;
                await driver.get(url);

                const inputFname = await driver.findElement(By.id('txt-first-name'));
                const inputLname = await driver.findElement(By.id('txt-last-name'));
                const output = await driver.findElement(By.id('output'));
            
                // Type a value into the input element
                await inputFname.sendKeys('John');

                // Type a value into the input element
                await inputLname.sendKeys('Doe');
            
                // Wait for the value to be displayed in the output element
                await driver.wait(until.elementTextContains(output, 'John'), 5000);
            
                // Check if the output element contains the input value
                const outputText = await output.getText();
                console.log(outputText);
                expect(outputText).to.include('John');
                expect(outputText).to.include('Doe');
			})

            after(async function () {

   
                const endTime = performance.now();
                const totalTime = (endTime - startTime) / 1000; // Convert to seconds
                console.log(`Total time taken: ${totalTime} seconds`);
      
                global.gradesObject[`${sessionNumber}`] = {
                  grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
                  score: `${passingTests}/${totalTests}`
                }
            
                jsonData.gradedTest.s47 = true;
                await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));
    
                // await driver.close()
                await driver.quit(); 
              });
		});
		
	} catch (err) {
		if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
		  console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
		} else {
		  console.log(err)
		}
	}

} else {
	console.log(`S${sessionNumber} - Tested`);
}


